
;****************************************************************************************
;*                            PFEIFEN LED                                               *
;*                              11.12.17                                                *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC12F683                                                  *
;* ALS OSZILLATOR WURDE INTERN RC-OSZILLATOR MIT 8,00MHZ GENOMMEN.                      *
;* (T=0.125SEC ALSO DIE TAKTZEIT)                                                      *
;* EIN BEFEHL HAT MEIST 4 TAKTE SIND 0,5SEC                                            *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;****************************************************************************************

        LIST    P=12F683       
        TITLE   "PFEIFE"

        ERRORLEVEL -302
        INCLUDE <P12F683.INC>

__CONFIG _INTRC_OSC_NOCLKOUT &_INTOSCIO & _IESO_OFF & _FCMEN_OFF &_WDT_OFF & _PWRTE_OFF & _BOD_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


MERK                    EQU 0X22
ZYKLUS                  EQU 0X23    ;BEI BIT0=1 WIRD ES DUNKLER /BEI=0 WIRD ES HELLER  //// BEI BIT 7=1 IST ZEIT AUS INTERRUPT ZU ENDE
ZAE                     EQU 0X24
ZAE1                    EQU 0X25
AD_H                    EQU 0X26
AD_L                    EQU 0X27
HELL_H                  EQU 0X28
HELL_L                  EQU 0X29
DUNKEL_H                EQU 0X2A
DUNKEL_L                EQU 0X2B
HELL0_H                 EQU 0X2C
HELL0_L                 EQU 0X2D
DUNKEL0_H               EQU 0X2E
DUNKEL0_L               EQU 0X2F
HELP                    EQU 0X30               ;FR PAUSE ZS100MSEC
HELP1                   EQU 0X31               ;FR PAUSE ZS100MSEC
;FR SPORADISCHE TABELLE
ZAEHLER                 EQU 0X32
TXT                     EQU 0X33

W_STACK                 EQU 0X34               ;FUER PUSH UND POP
S_STACK                 EQU 0X35               ;FUER PUSH UND POP


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

;STEHT NICHT IN INCULDED DATEI
GP1         EQU 1
GP4         EQU 4

;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; SOFORT INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              04.05.12                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK1

;OSCILLATOR AUF 8MHZ INTERN EINSTELLEN
                        MOVLW   B'01110101'
                        MOVWF   OSCCON

                        MOVLW   B'11111101'                 ;GP1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

                        MOVLW   B'00110100'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP DIGITAL I/O     AN3 -ANALOG/DIGITAL WANDLER MIT QUARZ-TAKT-INTERN  

;INIT TIMER 0 FUER 100MSEC 
                MOVLW   B'10000111'   ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                      ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG    ;MANCHMAL HEISST ES AUCH NUR OPTION AN STELLE VON OPTION_REG


                        BANK0                    

                        CLRF    GPIO
     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON0

                        BCF     GPIO, GP1                   ;LED AUS
                        ;BCF     ZYKLUS, BIT0                ;ZYKLUS SETZEN
                        CLRF    ZYKLUS
;INIT TIMER 1 
                        MOVLW   B'00000000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [00]1:1 VORERST 0
                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'10001000' ;ADMF=1 RECHTSBNDIG, VDD ALS REF, CHANNEL AN2, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZEITSCHLEIFE 300MSEC   ZUM AUFLADEN VON 47NF KONDENSATOR AM SCHLEIFER VOM EINSTELLREGLER FR AD-MESSUNG
                MOVLW   D'3'
                CALL    ZS100MSEC



                MOVLW   D'0'            ;ZAEHLER-BEGINN FR SPORADISCHE TABELLE
                MOVWF   ZAEHLER


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START           BCF     ZYKLUS, BIT7        ;ENDE ZEIT-INTERRUPT MERKER RCKSTELLEN

                BTFSS   ZYKLUS, BIT0
                GOTO    START1
                BCF     ZYKLUS, BIT0
                GOTO    START3

START1          BSF     ZYKLUS, BIT0


;AD-WANDLUNG
START3          BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                CALL    MUE40               ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                CALL    MUE40               ;ZEITSCHLEIFE

III             BTFSS  PIR1, ADIF
                GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    

;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;SIEHE BESCHREIBUNG BERECHNUNG UNTERHALB
;1X LINKS SCHIEBEN
                        RLF     AD_L, F
                        RLF     AD_H, F
                        BCF     STATUS, C

;1X LINKS SCHIEBEN
                        RLF     AD_L, F
                        RLF     AD_H, F
                        BCF     STATUS, C

;1X LINKS SCHIEBEN
                        RLF     AD_L, F
                        RLF     AD_H, F
                        BCF     STATUS, C

;AD-WERT+0XD862 = IN AD_L UND AD_H
                        MOVLW   0X62
                        ADDWF   AD_L, F

                        BTFSC   STATUS, C ;BERTRAG
                        INCF    AD_H, F

                        MOVLW   0XD8
                        ADDWF   AD_H, F


;ZEITBASIS TIMER1 :
;PRESCALER 1X  *  SYSTEM 4X  * TAKTZEIT ====> 1*4*0.125SEC=0,5SEC   

;;;
;511=0X1FF LASSEN DA 5/10MSEC FR EINEN ZYKLUS NICHT FLACKERN/FLIMMERN
;;;
;EINSTELLBEREICH MITTELS POTI VON 0,5SEC BIS 3SEC (DELTA CA. 2,5SEC)

;ZEITBASIS 0,5SEC 
;ES GILT 2,5SEC : 511 = 4,89MSEC : 0,5SEC = D'9780' = (0X2634) DIESEN WERT EINSTELLBAR MACHEN FR POTI

;BEI AD JETZT RECHTSBNDIG
;VON NULL BIS (D'1.024') 0X03FF MUSS MAN AUF OBIGES KOMMEN
;MIT EINMAL NACH LINKS SCHIEBEN 0X07FE = D'2.046' 
;NOCHMALS LINKS SCHIEBEN 0X0FFC = D'4.092'
;DAS DRITTE MAL NACH LINKS 0X1FF8 = D'8.184' KOMMT SO UNGEFHR HIN (BEIM 4-TEN MAL LINKS WAEREN ES CA. D'16.000' ZU GRO
;ERGEBNIS BEI 3MAL LINKS ERGIBT SICH MAX. WERT VON 8.184DEZ

;ES MUSS EIN WERT DAZU ADDIERT WERDEN, DA TIMER1 INCREMENTIERT BIS 0XFFFF
;0XFFFF - 0X1FF8 = 0XE007  
;0XE007 MUSS MAN HINZU ADDIEREN, DANN GEHT ES ABER BEI +5V AM SCHLEIFER VOM POTI ZU 0XFFFF

;ES MUSS NOCH DIE KLEINSTE ZEIT BEI 0,5SEC ABGEZOGEN WERDEN
;ES GILT: 0,5SEC IST DIE KLEINSTE ZEIT /// 0,5SEC : 511 = 0,978MSEC : 0,5SEC = 1.957DEZ (0X07A5)

;0XE007 - 0X07A5 = 0XD862
;ERGEBNIS: 0XD862 MUSS ADDIERT WERDEN ZUM GEMESSENEN POTI AD-WERT

;BEI +5V AM POTI UND 3MAL LINKSGESCHOBEN => 0X1FF8 + FESTER-WERT VON 0XD862 = 0XF85A D'63.578'
;IST DIE KRZESTE ZEIT MIT D'65.535'-D'63.578'= D'1.957' * 511 * 0,5SEC = 0,5SEC

;BEI 0V AM POTI /LINK-SCHIEBEN BRINGT NICHTS => 0X0000 + FESTER-WERT VON 0XD862 = 0XD862 D'55.394' 
;IST LNGSTE ZEIT MIT D'65.535'-D'55.394'= D'10.141' * 511 * 0,5SEC = 2,59SEC



                BTFSS   ZYKLUS, BIT0
                GOTO    ZY1

                MOVLW   0X01
                MOVWF   HELL0_L
                CLRF    HELL0_H
   
                MOVLW   0XFF
                MOVWF   DUNKEL0_L
                MOVLW   0X01
                MOVWF   DUNKEL0_H
                GOTO    ZY2

ZY1             MOVLW   0X01
                MOVWF   DUNKEL0_L
                CLRF    DUNKEL0_H
   
                MOVLW   0XFF
                MOVWF   HELL0_L
                MOVLW   0X01
                MOVWF   HELL0_H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;INTERRUPT ZULASSEN
ZY2             BSF     INTCON, GIE     ;ALLGEMEINES INTERRUPT ENABLE
                BSF     INTCON, PEIE
                BANK1
                BSF     PIE1, TMR1IE    ;OVERFLOW INTERRUPT BEI TIMER1 ZULASSEN/ENABLE
                BANK0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN
                BSF     T1CON, TMR1ON   ;START DES TIMER1

;---------------INITIALISIERUNG--ZU--ENDE-----------------------
;---------------------------------------------------------------
;EINE PERIODE!!!!10SEC MIT EIN/AUS LED
;GESAMT: 0X01FF = 511DEZ. DURCHLUFE * 10SEC = CA.5MSEC  ENTSPRICHT 200HZ !!!
ANFANG      BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    ANFANG

                        MOVF    HELL0_L, W
                        MOVWF   HELL_L                 
                        MOVF    HELL0_H, W
                        MOVWF   HELL_H

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN

                        BSF     GPIO, GP1       ;LED EIN

WEITER1                 NOP         
                        NOP
                        NOP
                        NOP
                        NOP

                        NOP
                        NOP
                        NOP
                        NOP
                        NOP         ;10NOPS * 0,5SEC= 5SEC
 
                        MOVLW   D'1'        ;DURCHLAUF-ENDE ERKENNUNG
                        SUBWF   HELL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1
                        MOVLW   D'1'
                        SUBWF   HELL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1         

;------------------------------- 
SE1         BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    SE1
 
                        MOVF    DUNKEL0_L, W
                        MOVWF   DUNKEL_L                 
                        MOVF    DUNKEL0_H, W
                        MOVWF   DUNKEL_H   

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN

                        BCF     GPIO, GP1       ;LED AUS

WEITER2                 NOP         
                        NOP
                        NOP
                        NOP
                        NOP

                        NOP
                        NOP
                        NOP
                        NOP
                        NOP         ;10NOPS * 0,5SEC= 5SEC
 
                        MOVLW   D'1'            ;DURCHLAUF-ENDE ERKENNUNG
                        SUBWF   DUNKEL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2
                        MOVLW   D'1'
                        SUBWF   DUNKEL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2         


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        BTFSC   ZYKLUS, BIT7    ;NEU!!! ZYKLUSZEIT-ZEIT ZU ENDE ///DANN ERNEUT AD-MESSUNG ... NACH ENTWEDER HOCH ODER RUNTER FAHREN   
                        GOTO    ST1             ;EIN HALBER ZYKLUS-ZEIT IST ALSO UM
                        GOTO    ANFANG

ST1                     BTFSC   ZYKLUS, BIT0    ;BEI    WAR ES DUNKLER ALSO ES WURDE NACH RUNTER GEFAHREN
                        GOTO    START

;HIER KOMMT DIE PAUSE REIN ZWISCHEN DEM ZIGARETTE NICHT BRENNEN
                        BCF     GPIO, GP1   ;ES LEUCHTET NICHT MEHR NUR ZUR SICHERHEIT, WAR JA RUNTERGEFAHREN

                        BTFSC   GPIO, GP4   ;ZYKLISCH BEI LOW ODER SPORADISCH BEI HIGH AN GP4
                        GOTO    SPOR

;FR ZYKLISCH
                        MOVLW   D'20'       ;BEI ZYKLISCH ALSO IMMER GLEICH DIESE ZAHL /// 20*100MSEC=2000MSEC=2SEC
                        CALL    ZS100MSEC
                        GOTO    START

;FR SPORADISCH
SPOR                CALL    TABELLE
                    MOVWF   TXT
                    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W
                    BTFSS   STATUS, Z
                    GOTO    WEITERX
                    MOVLW   D'0'            ;TABELLENENDE ERKANNT
                    MOVWF   ZAEHLER
                    GOTO    SPOR

WEITERX             INCF    ZAEHLER, F

                    MOVF    TXT, W
                    CALL    ZS100MSEC
                    GOTO    START


;*****************************************************************************
;*                              INTERRUPT                                    *
;*****************************************************************************
INTERRUPT       PUSH
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                BTFSS   ZYKLUS, BIT0
                GOTO    ZZY1

                MOVLW   D'1'            
                SUBWF   DUNKEL0_L, F
                BTFSC   STATUS, C
                GOTO    INT1
                DECF    DUNKEL0_H, F

INT1            INCFSZ  HELL0_L, F
                GOTO    INT2
                INCF    HELL0_H, F

INT2            MOVLW   0XFE            ;ENDE BEI 0X03FE -- HELL0                   
                SUBWF   HELL0_L, W
                BTFSS   STATUS, Z
                GOTO    AA1

                MOVLW   0X01                   
                SUBWF   HELL0_H, W
                BTFSS   STATUS, Z
                GOTO    AA1
                BSF     ZYKLUS, BIT7    ;AUF + ABSCHWELLEN EINSTELLEN MERKEN INT ZU ENDE
                GOTO    AA2 

;----
ZZY1            MOVLW   D'1'            
                SUBWF   HELL0_L, F
                BTFSC   STATUS, C
                GOTO    INTA
                DECF    HELL0_H, F

INTA            INCFSZ  DUNKEL0_L, F
                GOTO    INTB
                INCF    DUNKEL0_H, F

INTB            MOVLW   0XFE            ;ENDE BEI 0X03FE -- DUNKEL0                   
                SUBWF   DUNKEL0_L, W
                BTFSS   STATUS, Z
                GOTO    AA1

                MOVLW   0X01                   
                SUBWF   DUNKEL0_H, W
                BTFSS   STATUS, Z
                GOTO    AA1
                BSF     ZYKLUS, BIT7    ;AUF + ABSCHWELLEN EINSTELLEN MERKEN INT ZU ENDE
                GOTO    AA2 
;---  

AA1             BSF     T1CON, TMR1ON   ;START DES TIMER1
AA2             POP
                RETFIE

;*****************************************************************************
;*                              CA. 40S ZEITSCHLEIFE                        *
;*****************************************************************************

MUE40       MOVLW   D'8'
            MOVWF   ZAE1
MSA2        NOP             
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP                        ;10*NOPS = 10*0,5SEC=5SEC   5SEC*8=40SEC
            DECFSZ  ZAE1, F
            GOTO    MSA2
            RETURN

;*****************************************************************************
;*                              UNTERPROGRAMM 100MSEC ZEITSCHLEIFE           *
;*****************************************************************************
ZS100MSEC               MOVWF   HELP

ZS23                    MOVLW   D'10'
                        MOVWF   HELP1

ZS21                    MOVLW   D'178'
                        MOVWF   TMR0                    
                        BCF     INTCON, T0IF           
                
ZS22                    BTFSS   INTCON, T0IF           
                        GOTO    ZS22                    

                        DECFSZ  HELP1, F               
                        GOTO    ZS21                    

                        DECFSZ  HELP, F               
                        GOTO    ZS23                    
                        RETURN


;ZEITBERECHNUNG FUER 10MS*10=100MSEC

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.125SEC=128SEC 
;10MS : 128SEC= 78,125  GENOMMEN GANZAHLIG 78
;ALSO NACHRECHNUNG 
;128SEC*D'78'=9,984MSEC
;TMR0 ALSO D'256'-D'78'=D'178' ENTSPRICHT CA. 10MSEC
;178 DEZIMAL OBEN EINTRAGEN


    ORG 0X0200

;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       ZEILENWEISE EINZELN LADEN                           *
;*****************************************************************************
TABELLE
    MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0200 
    MOVWF   PCLATH

    MOVF    ZAEHLER, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F          ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;ES KOENNEN CA. 240 ZEILEN MIT RETLW EINGETRAGEN WERDEN /// ALSO BIS SPEICHERENDE 0X1FF /// KONTROLLIERE LIST-FILE

    RETLW D'25'     ;BEISPIEL : 25*100MSEC=2500MSEC=2,5SEC
    RETLW D'10' 
    RETLW D'5' 
    RETLW D'30' 
    RETLW D'1'      ;1 IST DIE KLEINSTE ZAHL WELCHE MAN EINTRAGEN KANN / ALSO 100MSEC / NULL GEHT NICHT
 
    RETLW D'15'  
    RETLW D'8' 
    RETLW D'15' 
    RETLW D'40' 
    RETLW D'3'

    RETLW D'25'  
    RETLW D'10' 
    RETLW D'30' 
    RETLW D'6' 
    RETLW D'8' 

    RETLW D'25'  
    RETLW D'1' 
    RETLW D'18' 
    RETLW D'2' 
    RETLW D'9' 

    RETLW D'40'  
    RETLW D'20' 
    RETLW D'2' 
    RETLW D'22' 
    RETLW D'5'

    RETLW D'10'  
    RETLW D'1' 
    RETLW D'20' 
    RETLW D'9' 
    RETLW D'25' 

    RETLW 0XFF      ;ENDE-ERKENNUNG




            END
